#!/bin/env python
import os,sys,argparse
import register
import util

def args_parsing(args):

    argparser = argparse.ArgumentParser(prog=os.path.basename(args[0]))
    argparser.add_argument('registerfile', help='register file given as input')
    argparser.add_argument('dotfile',nargs='?',default='', help='dot file used as output')

    parse_result=argparser.parse_args(args[1:])
    
    registerfile=os.path.abspath(parse_result.registerfile).replace('\\','/')
    util.check_isreadablefile(registerfile)
    if parse_result.dotfile: 
        dotfile=os.path.abspath(parse_result.dotfile).replace('\\','/')
    else:
        dotfile=registerfile+".dot" 
    return  (registerfile,dotfile)

def main(args):
    (in_infile,out_dotfile)=args_parsing(args)
    print "register2dot: " + in_infile + " -> " + out_dotfile

    regmodel=register.from_xml(in_infile)
    regmodel.to_dotfile(out_dotfile)

    



if __name__ == "__main__":
    main(sys.argv)


