/*
 * sut is generated from model  : {{ model_file }}
 */

package {{ package }};

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

//0.3 import org.apache.log4j.Logger;

public class {{ className }} implements sut.interfaces.SutInterface {
    //0.3 private static final Logger logger = Logger.getLogger({{ className }}.class);

    // define State interface
    public interface State {
      OutputAction handle(  InputAction input );
    }

    private Random random = new Random(0); 

    // Initialize statemachine constants,variables and locations
    {% for name in constants -%}
    final int {{ name  }} = {{ constants[name][1] }};
    {% endfor %}
    
    // declaration statevars
    {% for name in statevars -%}
    int {{ name  }};
    {% endfor %}    
    
    
    
    // stateID
    // enum for StateID
    public enum StateID {
        {% for location in locations -%}
        {{ location  }},
        {% endfor -%}
        ERR
    }
     
    // declaration current state 
    public State currentState;

    //constructor: initializes by calling sendReset
    public {{ className }}() {
         sendReset();
    }
    





    {% for location in locations -%}
        
       
    State state_{{ location  }} = new State() {
        
        public StateID id = StateID.{{location}};
        
        public OutputAction handle(  InputAction in ) {
           // helpers for output           
           String methodName = "Oquiescence";
           List < Parameter > result = new ArrayList < Parameter > ();           
           
           switch ( in.getMethodName() )  {
           
           {% for input in inputInterfaces -%}
           case "{{input}}":  
           { 
               {%- for paramtype in inputInterfaces[input] %}
               int tomte_p{{- loop.index0 -}} = in.getParam( {{- loop.index0 -}} ).getValue();
               {%- endfor %}
               {%- set inputtransitions=state2input2inputtransitions[location][input]  -%}
               {%- if  inputtransitions %}
                    {% for inputtransition in inputtransitions -%}
                        {%- if inputtransition['guard'] -%}                    
                        if ( {{ inputtransition['guard'] }} ) {
                        {% endif -%}   
                                // update action  (for input transition)
                                {%- for action_statement in inputtransition['action_statements'] %}
                                {{action_statement}};
                                {%- endfor %}
                                
                                // loop over output transitions for selected input transition
                                {% for outputtransition in inputtransition['outputtransitions'] -%}
                                    {%- if outputtransition['guard'] -%}                    
                                    if ( {{ outputtransition['guard'] }} ) {
                                    {% endif -%}                                       
                                        // update action  (for output transition)
                                        {%- for action_statement in outputtransition['action_statements'] %}
                                        {{action_statement}};
                                        {%- endfor %}                                    
                                        // change state
                                        currentState= state_{{ outputtransition['target'] }};
                                        //setup output name and params 
                                        methodName = "{{ outputtransition['name'] }}";
                                        {%- for param in outputtransition['params'] %}
                                        result.add(new Parameter({{ param }}, {{ loop.index0 }} ));
                                        {%- endfor %}
                                        break;
                                    {%- if outputtransition['guard'] -%}                    
                                    }
                                    {% endif -%}
                                {%- endfor -%}                                                                          
                        {%- if inputtransition['guard'] -%}                    
                        }
                        {% endif -%}                           
                    {%- endfor -%}
               {%- else -%}
                   break;     
               {%- endif -%}              
           }   
           {% endfor %}
           }
        
           return new OutputAction(methodName, result); 
        }       
    };
    
    {% endfor -%}


    

    @Override
  	public sut.interfaces.OutputAction sendInput( sut.interfaces.InputAction action) {
  		InputAction ia = new InputAction(action);    // copy input
      return currentState.handle(ia);
  	}
  
  	@Override
  	public void sendReset() {
          {% for name in statevars -%}
          {{ name  }} = {{ statevars[name][1] }};
          {% endfor -%}
          
          currentState = state_{{initlocation}};
  	}


    // methods for main
    //-------------------
  	public void reset() {
          sendReset();
  	}
   
    // OutputAction means {{ package }}.OutputAction not sut.interfaces.OutputAction 
    public OutputAction  processSymbol(InputAction inputAction) {
           return (OutputAction) sendInput(inputAction);           
    }


}
