/*
 * sut is generated from model  : {{ model_file }}
 */

package {{ package }};

import java.util.ArrayList;
import java.util.List;

//0.3 import org.apache.log4j.Logger;

public class {{ className }} implements sut.interfaces.SutFsmInterface {
    //0.3 private static final Logger logger = Logger.getLogger({{ className }}.class);

    // define State interface
    public interface State {
      String handle(  String input );
    }

    
    // stateID
    // enum for StateID
    public enum StateID {
        {% for location in locations -%}
        state_{{ location  }},
        {% endfor -%}
        ERR
    }
     
    // declaration current state 
    public State currentState;

    //constructor: initializes by calling sendReset
    public {{ className }}() {
         reset();
    }
    

    {% for location in locations -%}
        
       
    State state_{{ location  }} = new State() {
        
        public StateID id = StateID.state_{{location}};
        
        public String handle(  String input ) {
           // helpers for output           
           String output = "Oquiescence";
           
           switch ( input )  {
           {% for input in inputs -%}
           case "{{input}}":  
           { 
               {%- set transition=state2input2transition[location][input]  -%}
               {%- if  transition %}
               currentState= state_{{ transition['target'] }};
               output = "{{ transition['output'] }}";
               break;  
               {%- else %}
               break;     //  output = "Oquiescence" (default)
               {%- endif %} 
           
           }           
           {% endfor %}
           }
           
           return output; 
        }       
    };
    
    {% endfor -%}


    



    // methods implementing sut.interfaces.SutFsmInterface
    //----------------------------------------------------
  	public void reset() {
  		currentState = state_{{initlocation}};
  	}
   
    public String  step(String input) {
        return currentState.handle(input);    // side effect is changing currentState      
    }

  	public List getInputAlphabet() {
  		ArrayList<String> inputs=new ArrayList<String>();
  		{% for input in inputs -%}
  		inputs.add("{{input}}");
  		{% endfor %}
  		return inputs;
  	}

}
