#!/bin/env python
import os,sys,argparse
import pyuppaal
import util

def args_parsing(args):

    argparser = argparse.ArgumentParser(prog=os.path.basename(args[0]))
    argparser.add_argument('uppaalfile', help='uppaal file given as input')
    argparser.add_argument('dotfile',nargs='?',default='', help='dot file used as output')

    parse_result=argparser.parse_args(args[1:])
    
    uppaalfile=os.path.abspath(parse_result.uppaalfile).replace('\\','/')
    util.check_isreadablefile(uppaalfile)
    if parse_result.dotfile: 
        dotfile=os.path.abspath(parse_result.dotfile).replace('\\','/')
    else:
        dotfile=uppaalfile+".dot" 
    return  (uppaalfile,dotfile)

def main(args):
    (in_uppaalfile,out_dotfile)=args_parsing(args)
    print "uppaalToDot: " + in_uppaalfile + " -> " + out_dotfile
    uppaalModel=pyuppaal.from_xml(in_uppaalfile)
    uppaalModel.templates[0].removeNails()
    uppaalModel.templates[0].export_dot(outfile=out_dotfile)

    



if __name__ == "__main__":
    main(sys.argv)


