#!/bin/env python
import os,sys,argparse
import pyuppaal
import util

def args_parsing(args):

    argparser = argparse.ArgumentParser(prog=os.path.basename(args[0]))
    argparser.add_argument('uppaalfile', help='uppaal file given as input')
    argparser.add_argument('outfile',nargs='?',default='', help='file used to output layout; can be in format dia,dot,xdot,dia,pdf,ps,svg,gif,wbmp,jpg,png,..')

    parse_result=argparser.parse_args(args[1:])
    
    uppaalfile=os.path.abspath(parse_result.uppaalfile).replace('\\','/')
    util.check_isreadablefile(uppaalfile)
    if parse_result.outfile: 
        outfile=os.path.abspath(parse_result.outfile).replace('\\','/')
    else:
        outfile=uppaalfile+".pdf" 
    return  (uppaalfile,outfile)

def main(args):
    (in_uppaalfile,out_file)=args_parsing(args)
    print "uppaalToLayoutformat: " + in_uppaalfile + " -> " + out_file
    uppaalModel=pyuppaal.from_xml(in_uppaalfile)
    uppaalModel.templates[0].removeNails()
    uppaalModel.templates[0].export_png(outfile=out_file)

    



if __name__ == "__main__":
    main(sys.argv)


